Gets value

- « ReflectionProperty::getType

- ReflectionProperty::hasDefaultValue »

- PHP Manual
- ReflectionProperty
- Gets value

# ReflectionProperty::getValue

(PHP 5, PHP 7, PHP 8)

ReflectionProperty::getValue — Gets value

### Description

public ReflectionProperty::getValue(?object `$object` = `null`): mixed

Gets the property's value.

### Parameters

`object`

  If the property is non-static an object must be provided to fetch the property from. If you want to fetch the default property without providing an object use ReflectionClass::getDefaultProperties() instead.

### Return Values

The current value of the property.

### Changelog

Version | Description
--- | ---
8.1.0 | Private and protected properties can be accessed by ReflectionProperty::getValue() right away. Previously, they needed to be made accessible by calling ReflectionProperty::setAccessible(); otherwise a ReflectionException was thrown.
8.0.0 | `object` is nullable now.

### Examples

Example #1 ReflectionProperty::getValue() example

    <?phpclass Foo {    public static $staticProperty = 'foobar';        public $property = 'barfoo';    protected $privateProperty = 'foofoo';}$reflectionClass = new ReflectionClass('Foo');var_dump($reflectionClass->getProperty('staticProperty')->getValue());var_dump($reflectionClass->getProperty('property')->getValue(new Foo));$reflectionProperty = $reflectionClass->getProperty('privateProperty');$reflectionProperty->setAccessible(true); // only required prior to PHP 8.1.0var_dump($reflectionProperty->getValue(new Foo));?>

The above example will output:

    string(6) "foobar"
    string(6) "barfoo"
    string(6) "foofoo"

### See Also

- ReflectionProperty::setValue() - Set property value
- ReflectionProperty::setAccessible() - Set property accessibility
- ReflectionClass::getDefaultProperties() - Gets default properties
- ReflectionClass::getStaticPropertyValue() - Gets static property value